unit visurezoU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtCtrls, StdCtrls;

const
     Index_Depart = 16; { index du noeud de depart pour dessiner la mosaique }
     mos_imax = 50; { dimension horizontale maximale de la mosaique }
     mos_jmax = 50; { dimension verticale maximale de la mosaique }
     dim_mini = 1; { dimension minimales des zones de la mosaique developpables en sous-zones }
     cont_max = 98; { cont_max = mos_imax + mos_jmax - 2 }
     maxii=10;
     maxjj=10;
     d=50; { facteur d'etendue d'effet de lissage (+ petit => diffusion + etendue) }

type
    TForm1 = class(TForm)
           MainMenu1: TMainMenu;
           Fichier: TMenuItem;
           Nouveau: TMenuItem;
           Ouvrir: TMenuItem;
           Enregistrer: TMenuItem;
           EnregistrerSous: TMenuItem;
           Quitter: TMenuItem;
           Dessine: TMenuItem;
           mosaique_: TMenuItem;
           contours: TMenuItem;
           PageControl1: TPageControl;
           TabSheet1: TTabSheet;
           ScrollBox1: TScrollBox;
           Image1: TImage;
           TabSheet2: TTabSheet;
           ScrollBox2: TScrollBox;
           Image2: TImage;
           TabSheet3: TTabSheet;
           ScrollBox3: TScrollBox;
           Image3: TImage;
           lisse: TMenuItem;
           Nouveau1: TMenuItem;
           TabSheet4: TTabSheet;
           ScrollBox4: TScrollBox;
           Image4: TImage;
           seuil_: TMenuItem;
           LabelY: TLabel;
           LabelX: TLabel;
           LabelXnum: TLabel;
           LabelYnum: TLabel;
           Memo1: TMemo;
           procedure FormResize(Sender: TObject);
           procedure mosaique_Click(Sender: TObject);
           procedure NouveauClick(Sender: TObject);
           procedure contoursClick(Sender: TObject);
           procedure lisseClick(Sender: TObject);
           procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
           procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
           procedure Image1Click(Sender: TObject);
           procedure Image2Click(Sender: TObject);
           procedure Image4Click(Sender: TObject);
           procedure Nouveau1Click(Sender: TObject);
           procedure Image3Click(Sender: TObject);
           procedure seuil_Click(Sender: TObject);
           procedure FormCreate(Sender: TObject);
           procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
           procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
           procedure Image3MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
           procedure Image4MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
           procedure pickitup(i,j:integer);
           private
                  { Private declarations }
           public
                 { Public declarations }
    end;
    TLiens = array  [0..1000,1..3] of real; { TLiens[0,1] contient le nombre total de liens dans TLiens}
    TNoeuds = array [0..100] of string; {TNoeuds[0] contient le plus grand Index_URL enregistr }
    TMosaique = array [1..mos_imax,1..mos_jmax] of integer;
    TContour = array [1..cont_max,1..cont_max] of real;
    pTZone = ^TZone;
    TZone = record
          index,imin,imax,jmin,jmax : integer; { index du noeud de cette zone et dimensions }
          developpee,terminale:boolean; { false par defaut, true si on ne peut pas la developper car elle est trop petite }
          liste_souszones:pTZone;
          souszone_suivante:pTZone;
          suivante:pTZone;
    end;
    TMax = array[0..1000] of integer; { tableau temporaire contenant les Index_URL des valeurs maximums de liens
                                     TMax[0] contient le nombre de index_URL stocks }
    TPeek = array[0..100,1..2] of integer; { tableau contenant les numeros des noeuds autour de la souris.
                                        TPeek[0,1] contient le nb d'elts }
    pTPoint_ = ^TPoint_;
    TPoint_ = record
           x,y:integer;
           isole:boolean;
           point_suivant:pTPoint_;
    end;
    pTIlot = ^TIlot;
    TIlot = record  { un ilot est ensemble de points connexes dont la valeur contour lisse est au-dessus d'un seuil }
          liste_points:pTPoint_;
          ilot_suivant:pTIlot;
    end;

var
  Form1: TForm1;
  liens: TLiens;
  noeuds: TNoeuds;
  mosaique: TMosaique;
  contour,cont_haut,cont_bas,cont_lis_bas,cont_lis_haut,cont_lis,cont_seuil: TContour;
  liste_zones: pTZone;
  bitmapmos,bitmapcont,bitmaplis:TBitMap;
  sh:TShiftState;
  contimax,contjmax:integer;
  liste_ilots:pTIlot;

implementation

uses visurezou2;

{$R *.DFM}
{$M 16384, 209715352}

procedure TForm1.FormResize(Sender: TObject);
begin
     if height<300 then height:=300;
     if width<480 then width:=480;
     pagecontrol1.height:=height-80;
     pagecontrol1.width:=width-140;
     scrollbox1.height:=height-110;
     scrollbox1.width:=width-150;
     scrollbox2.height:=height-110;
     scrollbox2.width:=width-150;
     scrollbox3.height:=height-110;
     scrollbox3.width:=width-150;
     scrollbox4.height:=height-110;
     scrollbox4.width:=width-150;
     memo1.left:=width-130;
     memo1.height:=pagecontrol1.height;
     LabelX.top:=height-80;
     LabelY.top:=height-80;
     LabelXnum.top:=height-80;
     LabelYnum.top:=height-80;
end;

procedure TForm1.NouveauClick(Sender: TObject);
var
   i,j:integer;
begin
     for i:=0 to 1000 do for j:=1 to 3 do liens[i,j]:=0;
     for i:=0 to 100 do noeuds[i]:='';
     with datamodule1.tableliens do begin
          open;
          first;
          i:=1;
          while not eof do begin
                liens[i,1]:=fieldbyname('Index_URL').asinteger;
                liens[i,2]:=fieldbyname('Index_URL_liee').asinteger;
                liens[i,3]:=fieldbyname('Force_lien').asfloat;
                i:=i+1;
                next;
          end;
          liens[0,1]:=i-1;
          close;
     end;
     with datamodule1.tablenoeuds do begin
          open;
          first;
          i:=1;
          while not eof do begin
                noeuds[fieldbyname('Index_URL').asinteger]:=fieldbyname('URL').asstring;
                if i<fieldbyname('Index_URL').asinteger then i:=fieldbyname('Index_URL').asinteger;
                next;
          end;
          str(i,noeuds[0]);
          close;
     end;
     mosaique_.enabled:=true;
end;

function liens_voisin(extrait_liens:TLiens;zone,souszone:pTZone;ii,jj:integer):real;
var
   num_lien,num_noeud,compteur,surf_zone_voisine:integer;
   res:real;
   zone_voisine:pTZone;
begin
     res:=0;
     num_noeud:=0;
     surf_zone_voisine:=mos_imax*mos_jmax*2;
     zone_voisine:=liste_zones;
     while zone_voisine<>nil do begin
           if (zone_voisine^.imin<=ii) and (zone_voisine^.imax>=ii) and (zone_voisine^.jmin<=jj) and (zone_voisine^.jmax>=jj) then begin
              if zone_voisine<>zone then
              if surf_zone_voisine>(zone_voisine^.jmax-zone_voisine^.jmin)*(zone_voisine^.imax-zone_voisine^.imin) then begin
                 surf_zone_voisine:=(zone_voisine^.jmax-zone_voisine^.jmin)*(zone_voisine^.imax-zone_voisine^.imin);
                 num_noeud:=zone_voisine^.index;
              end;
              zone_voisine:=zone_voisine^.liste_souszones;
           end else zone_voisine:=zone_voisine^.souszone_suivante;
     end;
     if num_noeud<>0 then begin
        num_lien:=0;
        for compteur:=1 to round(extrait_liens[0,1]) do if extrait_liens[compteur,2]=num_noeud then num_lien:=compteur;
        if num_lien<>0 then res:=extrait_liens[num_lien,3];
     end;
     result:=res;
end;

procedure developpe(zone:pTZone);
var
   extrait_liens:TLiens;
   souszone:pTZone;
   i,j,imin_restant,jmin_restant,imax_restant,jmax_restant,n,
    ii,jj,imin_restant_hyp,imax_restant_hyp,jmin_restant_hyp,jmax_restant_hyp:integer;
   force_totale,lien_max,liens_hyp_1,liens_hyp_2:real;
   max:TMax;
begin
     if ((zone^.jmax-zone^.jmin) > dim_mini) or ((zone^.imax-zone^.imin) > dim_mini) then begin
        { extrait les liens relatifs au noeud zone^.index }
        j:=1;
        for i:=1 to trunc(liens[0,1]) do begin
            if liens[i,1]=zone^.index then begin
               extrait_liens[j,1]:=zone^.index;
               extrait_liens[j,2]:=liens[i,2];
               extrait_liens[j,3]:=liens[i,3];
               j:=j+1;
            end;
            if liens[i,2]=zone^.index then
            if liens[i,1]<>zone^.index then begin
               extrait_liens[j,1]:=zone^.index;
               extrait_liens[j,2]:=liens[i,1];
               extrait_liens[j,3]:=liens[i,3];
               j:=j+1;
            end;
        end;
        n:=j-1; { nombre de liens relatifs  zone^.index }
        extrait_liens[0,1]:=n;
        { / extrait les liens relatifs au noeuds zone^.index }
        if n > 1 then begin
           { trie ces liens par force decroissante }
           for i:=1 to n-1 do begin
               lien_max:=extrait_liens[i,3];
               max[0]:=1;
               max[1]:=i;
               for j:=i+1 to n do begin
                   if extrait_liens[j,3]>lien_max then begin
                      lien_max:=j;
                      max[0]:=1;
                      max[1]:=j;
                   end else if extrait_liens[j,3]=lien_max then begin
                       max[0]:=max[0]+1;
                       max[max[0]]:=j;
                   end;
               end;
               j:=max[trunc(random(max[0])+1)];
               if i<>j then begin
                  extrait_liens[n+1,1]:=extrait_liens[i,1];
                  extrait_liens[n+1,2]:=extrait_liens[i,2];
                  extrait_liens[n+1,3]:=extrait_liens[i,3];
                  extrait_liens[i,1]:=extrait_liens[j,1];
                  extrait_liens[i,2]:=extrait_liens[j,2];
                  extrait_liens[i,3]:=extrait_liens[j,3];
                  extrait_liens[j,1]:=extrait_liens[n+1,1];
                  extrait_liens[j,2]:=extrait_liens[n+1,2];
                  extrait_liens[j,3]:=extrait_liens[n+1,3];
               end;
           end;
           { / trie ces liens par force decroissante }
           force_totale:=0;
           for i:=1 to n do force_totale:=force_totale+extrait_liens[i,3];
           imin_restant:=zone^.imin;
           imax_restant:=zone^.imax;
           jmin_restant:=zone^.jmin;
           jmax_restant:=zone^.jmax;
           { calcule et developpe les sous-zones }
           for i:=1 to n do begin
               new(souszone);
               with souszone^ do begin
                    index:=trunc(extrait_liens[i,2]);
                    liste_souszones:=nil;
                    souszone_suivante:=zone^.liste_souszones;
                    zone^.liste_souszones:=souszone;
                    developpee:=false;
                    if (jmax_restant-jmin_restant)>(imax_restant-imin_restant) then begin
                       { dtermine si il vaut mieux positionner la nouvelle sous-zone en haut ou en bas
                         en fonction des liens avec les zones voisines dans chacune de ces 2 hypothses }
                       { Hypothse haute }
                       jmax_restant_hyp:=round(jmin_restant+(jmax_restant-jmin_restant)*extrait_liens[i,3]/force_totale);
                       liens_hyp_1:=0;
                       jj:=jmin_restant-1;
                       if jj>0 then for ii:=imin_restant to imax_restant do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       ii:=imin_restant-1;
                       if ii>0 then for jj:=jmin_restant to jmax_restant_hyp do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       ii:=imax_restant+1;
                       if ii<mos_imax+1 then for jj:=jmin_restant to jmax_restant_hyp do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       { / Hypothse haute }
                       { Hypothse basse }
                       jmin_restant_hyp:=round(jmax_restant-(jmax_restant-jmin_restant)*extrait_liens[i,3]/force_totale);
                       liens_hyp_2:=0;
                       jj:=jmax_restant+1;
                       if jj<mos_jmax+1 then for ii:=imin_restant to imax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       ii:=imin_restant-1;
                       if ii>0 then for jj:=jmin_restant_hyp to jmax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       ii:=imax_restant+1;
                       if ii<mos_imax+1 then for jj:=jmin_restant_hyp to jmax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       { / Hypothse basse }
                       { / dtermine si il vaut mieux positionner la nouvelle sous-zone en haut ou en bas
                         en fonction des liens avec les zones voisines dans chacune de ces 2 hypothses }
                       if liens_hyp_1>liens_hyp_2 then begin
                          imin:=imin_restant;
                          jmin:=jmin_restant;
                          jmax:=jmax_restant_hyp;
                          imax:=imax_restant;
                          jmin_restant:=jmax+1;
                       end else begin
                           imax:=imax_restant;
                           jmax:=jmax_restant;
                           jmin:=jmin_restant_hyp;
                           imin:=imin_restant;
                           jmax_restant:=jmin-1;
                       end;
                    end else begin
                       { dtermine si il vaut mieux positionner la nouvelle sous-zone  gauche ou  droite
                         en fonction des liens avec les zones voisines dans chacune de ces 2 hypothses }
                       { Hypothse gauche }
                       imax_restant_hyp:=round(imin_restant+(imax_restant-imin_restant)*extrait_liens[i,3]/force_totale);
                       liens_hyp_1:=0;
                       ii:=imin_restant-1;
                       if ii>0 then for jj:=jmin_restant to jmax_restant do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       jj:=jmin_restant-1;
                       if jj>0 then for ii:=imin_restant to imax_restant_hyp do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       jj:=jmax_restant+1;
                       if jj<mos_jmax+1 then for ii:=imin_restant to imax_restant_hyp do
                       liens_hyp_1:=liens_hyp_1+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       { / Hypothse gauche }
                       { Hypothse droite }
                       imin_restant_hyp:=round(imax_restant-(imax_restant-imin_restant)*extrait_liens[i,3]/force_totale);
                       liens_hyp_2:=0;
                       ii:=imax_restant+1;
                       if ii<mos_imax+1 then for jj:=jmin_restant to jmax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       jj:=jmin_restant-1;
                       if jj>0 then for ii:=imin_restant_hyp to imax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       jj:=jmax_restant+1;
                       if jj<mos_jmax+1 then for ii:=imin_restant_hyp to imax_restant do
                       liens_hyp_2:=liens_hyp_2+liens_voisin(extrait_liens,zone,souszone,ii,jj);
                       { / Hypothse droite }
                       { / dtermine si il vaut mieux positionner la nouvelle sous-zone  gauche ou  droite
                         en fonction des liens avec les zones voisines dans chacune de ces 2 hypothses }
                        if liens_hyp_1>liens_hyp_2 then begin
                           imin:=imin_restant;
                           jmin:=jmin_restant;
                           imax:=imax_restant_hyp;
                           jmax:=jmax_restant;
                           imin_restant:=imax+1;
                        end else begin
                            imax:=imax_restant;
                            jmax:=jmax_restant;
                            imin:=imin_restant_hyp;
                            jmin:=jmin_restant;
                            imax_restant:=imin-1;
                        end;
                    end;
                    terminale:=false;
                    suivante:=liste_zones;
                    liste_zones:=souszone;
{                    developpe(souszone);}
                    if (jmin_restant>jmax_restant) or (imin_restant>imax_restant) then break;
               end;
               force_totale:=force_totale-extrait_liens[i,3];
           end;
           zone^.developpee:=true;
           { / calcule et developpe les sous-zones }
        end;
     end else begin
         zone^.terminale:=true;
         zone^.developpee:=true;
     end;
end;

procedure TForm1.mosaique_Click(Sender: TObject);
var
   zone,premiere_zone_developpee,derniere_zone_non_developpee:pTZone;
{   code,nb_noeuds,}i,j:integer;
begin
     new(zone);
     with zone^ do begin
          index:=Index_Depart;
          imin:=1;
          imax:=mos_imax;
          jmin:=1;
          jmax:=mos_jmax;
          terminale:=false;
          developpee:=false;
          liste_souszones:=nil;
          souszone_suivante:=nil;
          suivante:=nil;
     end;
     liste_zones:=zone;
     developpe(zone); { developpe place la zone developpee en fin de liste,
                      les premieres zones de la liste sont non dveloppes }
     while liste_zones^.developpee=false do begin
           { recherche et dveloppe la dernire zone non dveloppe dans l'ordre de la liste,
           c'est--dire la zone non dveloppe de plus haut niveau dans l'arborescence des zones et sous-zones }
           derniere_zone_non_developpee:=liste_zones;
           premiere_zone_developpee:=liste_zones;
           while (premiere_zone_developpee<>nil) and (premiere_zone_developpee^.developpee=false) do begin
                 derniere_zone_non_developpee:=premiere_zone_developpee;
                 premiere_zone_developpee:=premiere_zone_developpee^.suivante;
           end;
           if derniere_zone_non_developpee^.developpee=false then developpe(derniere_zone_non_developpee);
           { / recherche et dveloppe la dernire zone non dveloppe dans l'ordre de la liste,
           c'est--dire la zone non dveloppe de plus haut niveau dans l'arborescence des zones et sous-zones }
     end;
     zone:=liste_zones;
     while zone<>nil do begin
           if zone^.terminale=true then
           for i:=zone^.imin to zone^.imax do
           for j:=zone^.jmin to zone^.jmax do mosaique[i,j]:=zone^.index;
           zone:=zone^.suivante;
     end;
     BitMapMos:=TBitMap.Create;
     with bitmapmos do begin
          width:=mos_imax;
          height:=mos_jmax;
{          val(noeuds[0],nb_noeuds,code);}
          for i:=1 to mos_imax do for j:=1 to mos_jmax do
{          canvas.pixels[i-1,j-1]:=round(mosaique[i,j]/nb_noeuds*255)*65793;}
           if mosaique[i,j]<5 then canvas.pixels[i-1,j-1]:=0*65793
           else if mosaique[i,j]=5 then canvas.pixels[i-1,j-1]:=42*65793
           else if (mosaique[i,j]>5) and (mosaique[i,j]<10) then canvas.pixels[i-1,j-1]:=84*65793
           else if mosaique[i,j]=10 then canvas.pixels[i-1,j-1]:=127*65793
           else if (mosaique[i,j]>10) and (mosaique[i,j]<15) then canvas.pixels[i-1,j-1]:=169*65793
           else if mosaique[i,j]=15 then canvas.pixels[i-1,j-1]:=213*65793
           else if mosaique[i,j]=16 then canvas.pixels[i-1,j-1]:=255*65793;
     end;
     image1.picture.graphic:=bitmapmos;
     image1.autosize:=true;
     mosaique_.checked:=true;
     mosaique_.enabled:=false;
     contours.enabled:=true;
end;

procedure TForm1.contoursClick(Sender: TObject);
var
   i,j,l:longint;
   lien,lienmax:real;
begin
     { dtermine la matrice des limites entre zones (contours) }
     lienmax:=0;
     for i:=1 to cont_max do for j:=1 to cont_max do contour[i,j]:=0;
     for i:=1 to mos_imax do for j:=1 to mos_jmax do begin
         if i<mos_imax then begin
            lien:=0;
            for l:=1 to trunc(liens[0,1]) do
            if ((liens[l,1]=mosaique[i,j]) and (liens[l,2]=mosaique[i+1,j]))
            or ((liens[l,2]=mosaique[i,j]) and (liens[l,1]=mosaique[i+1,j]))
            then begin
                 lien:=liens[l,3];
                 break;
            end;
            contour[i+j-1,j-i+mos_imax-1]:=lien;
            if lien>lienmax then lienmax:=lien;
         end;
         if j<mos_jmax then begin
            lien:=0;
            for l:=1 to trunc(liens[0,1]) do
            if ((liens[l,1]=mosaique[i,j]) and (liens[l,2]=mosaique[i,j+1]))
            or ((liens[l,2]=mosaique[i,j]) and (liens[l,1]=mosaique[i,j+1]))
            then begin
                 lien:=liens[l,3];
                 break;
            end;
            contour[i+j-1,j-i+mos_imax]:=lien;
            if lien>lienmax then lienmax:=lien;
         end;
     end;
     { / dtermine la matrice des limites entre zones (contours) }
     BitMapCont:=TBitMap.Create;
     with bitmapcont do begin
          width:=mos_imax*8;
          height:=mos_jmax*8;
          for i:=1 to mos_imax*8 do for j:=1 to mos_jmax*8 do
          if (i+j>8) and (i+j<(mos_imax+mos_jmax)*8-9) and (j-i+mos_imax*8>8) and (j-i<mos_jmax*8-9) then
          canvas.pixels[i-1,j-1]:=round(contour[trunc((i+j)/8),trunc((j-i)/8+mos_imax)]*255/lienmax)*65793
          else canvas.pixels[i-1,j-1]:=0;
     end;
     image2.picture.graphic:=bitmapcont;
     image2.autosize:=true;
     image2.autosize:=false;
     image2.stretch:=true;
     image2.width:=round(image2.width/8);
     image2.height:=round(image2.height/8);
     contours.checked:=true;
     contours.enabled:=false;
     lisse.enabled:=true;
end;

procedure TForm1.lisseClick(Sender: TObject);
var
   i,j,ii,jj,iii,jjj,t,tt:integer;
   xx,xy,yy,min,max,moy,facteur:real;
   ya:boolean;
begin
     { dtermine la matrice des contours aprs lissage }
     for i:=1 to cont_max do for j:=1 to cont_max do begin
         cont_lis[i,j]:=0;
         cont_lis_bas[i,j]:=0;
         cont_lis_haut[i,j]:=0;
     end;
     min:=1000000;
     max:=-1000000;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if min>contour[i,j] then min:=contour[i,j];
         if max<contour[i,j] then max:=contour[i,j];
     end;
     moy:=(max+min)/2;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if contour[i,j]>moy then begin
            cont_haut[i,j]:=contour[i,j]-moy;
            cont_bas[i,j]:=0;
         end else if contour[i,j]<moy then begin
             cont_haut[i,j]:=0;
             cont_bas[i,j]:=moy-contour[i,j];
         end else begin
             cont_haut[i,j]:=0;
             cont_bas[i,j]:=0;
         end;
     end else begin
         cont_haut[i,j]:=0;
         cont_bas[i,j]:=0;
     end;
     { lisse les valeurs suprieures  la moyenne de la matrice des contours }
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_haut[i,j]<>0 then begin
            xx:=0;
            xy:=0;
            yy:=0;
            for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
            if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
            and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
                if (i+ii)>0 then
                if (i+ii)<cont_max+1 then
                if (j+jj)>0 then
                if (j+jj)<cont_max+1 then begin
                   facteur:=1+((ii*ii)*sqr(d/mos_imax)+(jj*jj)*sqr(d/mos_jmax));
                   xx:=xx+ii*ii*cont_haut[i+ii,j+jj]/facteur;
                   xy:=xy+ii*jj*cont_haut[i+ii,j+jj]/facteur;
                   yy:=yy+jj*jj*cont_haut[i+ii,j+jj]/facteur;
                end;
            end;
            for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
            if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
            and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
                if (i+ii)>0 then
                if (i+ii)<cont_max+1 then
                if (j+jj)>0 then
                if (j+jj)<cont_max+1 then if (xx+2*xy+yy)<>0 then begin
                   facteur:=1+(xx*ii*ii*sqr(d/mos_imax)+2*xy*ii*jj*sqr(d)/mos_imax/mos_jmax+yy*jj*jj*sqr(d/mos_jmax))/(xx+2*xy+yy);
                   cont_lis_haut[i+ii,j+jj]:=cont_lis_haut[i+ii,j+jj]+cont_haut[i,j]/facteur;
                end;
            end;
         end;
     end;
     { / lisse les valeurs suprieures  la moyenne de la matrice des contours }
     { normalise les valeurs suprieures  la moyenne de la matrice des contours lisss }
     min:=1000000;
     max:=-1000000;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_lis_haut[i,j]>max then max:=cont_lis_haut[i,j];
         if cont_lis_haut[i,j]<min then min:=cont_lis_haut[i,j];
     end;
     if max<>min then for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then
     cont_lis_haut[i,j]:=(cont_lis_haut[i,j]-min)*100/(max-min);
     { / normalise les valeurs suprieures  la moyenne de la matrice des contours lisss }
     { lisse les valeurs infrieures  la moyenne de la matrice des contours }
{ lissage elliptique }
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_bas[i,j]<>0 then begin
            xx:=0;
            xy:=0;
            yy:=0;
            for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
            if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
            and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
                if (i+ii)>0 then
                if (i+ii)<cont_max+1 then
                if (j+jj)>0 then
                if (j+jj)<cont_max+1 then begin
                   facteur:=1+((ii*ii)*sqr(d/mos_imax)+(jj*jj)*sqr(d/mos_jmax));
                   xx:=xx+ii*ii*cont_bas[i+ii,j+jj]/facteur;
                   xy:=xy+ii*jj*cont_bas[i+ii,j+jj]/facteur;
                   yy:=yy+jj*jj*cont_bas[i+ii,j+jj]/facteur;
                end;
            end;
            for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
            if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
            and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
                if (i+ii)>0 then
                if (i+ii)<cont_max+1 then
                if (j+jj)>0 then
                if (j+jj)<cont_max+1 then if (xx+2*xy+yy)<>0 then begin
                   facteur:=1+(xx*ii*ii*sqr(d/mos_imax)+2*xy*ii*jj*sqr(d)/mos_imax/mos_jmax+yy*jj*jj*sqr(d/mos_jmax))/(xx+2*xy+yy);
                   cont_lis_bas[i+ii,j+jj]:=cont_lis_bas[i+ii,j+jj]-cont_bas[i,j]/facteur;
                end;
            end;
         end;
     end;
{ lissage linaire orient sur les diagonales }
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
         if (ii=jj) or (ii=-jj) then
         if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
         and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
             if ((i+ii)>0) and ((i+ii)<cont_max+1) and ((j+jj)>0) and ((j+jj)<cont_max+1) then
             if (cont_bas[i,j]<>0) and (cont_bas[i+ii,j+jj]<>0) then
             if (ii<>0) or (jj<>0) then begin
                tt:=abs(ii);
                ya:=false;
                for t:=0 to tt do begin
                   iii:=i+t*round(ii/tt);
                   jjj:=j+t*round(jj/tt);
                   if (iii>0) and (jjj>0) and (iii<cont_max+1) and (jjj<cont_max+1) then
                   if (i<>iii) or (j<>jjj) then if (i+ii<>iii) or (j+jj<>jjj) then
                   if cont_bas[iii,jjj]>=(cont_bas[i,j]+cont_bas[i+ii,j+jj])/2 then ya:=true;
                end;
                if ya=true then for t:=0 to tt do begin
                   iii:=i+t*round(ii/tt);
                   jjj:=j+t*round(jj/tt);
                   if (iii>0) and (jjj>0) and (iii<cont_max+1) and (jjj<cont_max+1) then
                   {if (i<>iii) or (j<>jjj) then if (i+ii<>iii) or (j+jj<>jjj) then}
                   cont_lis_bas[iii,jjj]:=cont_lis_bas[iii,jjj]-0.005*(cont_bas[i,j]+cont_bas[i+ii,j+jj]);
                end;
             end;
         end;
     end;
{ lissage linaire }
{     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
         if (i+ii+j+jj>mos_imax-1) and (i+ii+j+jj<2*cont_max-mos_imax+3)
         and (j+jj+cont_max-i-ii>mos_jmax-2) and (j+jj+cont_max-i-ii<2*cont_max-mos_jmax+2) then begin
             if ((i+ii)>0) and ((i+ii)<cont_max+1) and ((j+jj)>0) and ((j+jj)<cont_max+1) then
             if (cont_bas[i,j]<>0) and (cont_bas[i+ii,j+jj]<>0) then
             if (ii<>0) or (jj<>0) then begin
                iii:=-1;
                jjj:=-1;
                tt:=abs(ii)+abs(jj);
                ya:=false;
                for t:=0 to tt do
                if (iii<>round(i+t/tt*ii)) or (jjj<>round(j+t/tt*jj)) then begin
                   iii:=round(i+t/tt*ii);
                   jjj:=round(j+t/tt*jj);
                   if (iii>0) and (jjj>0) and (iii<cont_max+1) and (jjj<cont_max+1) then
                   if (i<>iii) or (j<>jjj) then if (i+ii<>iii) or (j+jj<>jjj) then
                   if cont_bas[iii,jjj]>=(cont_bas[i,j]+cont_bas[i+ii,j+jj])/2 then ya:=true;
                end;
                iii:=-1;
                jjj:=-1;
                if ya=true then for t:=0 to tt do
                if (iii<>round(i+t/tt*ii)) or (jjj<>round(j+t/tt*jj)) then begin
                   iii:=round(i+t/tt*ii);
                   jjj:=round(j+t/tt*jj);
                   if (iii>0) and (jjj>0) and (iii<cont_max+1) and (jjj<cont_max+1) then
                   {if (i<>iii) or (j<>jjj) then if (i+ii<>iii) or (j+jj<>jjj) then
                   cont_lis_bas[iii,jjj]:=cont_lis_bas[iii,jjj]-(cont_bas[i,j]+cont_bas[i+ii,j+jj]);
                end;
             end;
         end;
     end;
     { / lisse les valeurs infrieures  la moyenne de la matrice des contours }
     { normalise les valeurs infrieures  la moyenne de la matrice des contours lisss }
     min:=1000000;
     max:=-1000000;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_lis_bas[i,j]>max then max:=cont_lis_bas[i,j];
         if cont_lis_bas[i,j]<min then min:=cont_lis_bas[i,j];
     end;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if max<>min then if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then
     cont_lis_bas[i,j]:=0-(cont_lis_bas[i,j]-max)*100/(min-max);
     { / normalise les valeurs infrieures  la moyenne de la matrice des contours lisss }
     for i:=1 to cont_max do for j:=1 to cont_max do cont_lis[i,j]:=cont_lis_haut[i,j]+cont_lis_bas[i,j];
     min:=1000000;
     max:=-1000000;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_lis[i,j]>max then max:=cont_lis[i,j];
         if cont_lis[i,j]<min then min:=cont_lis[i,j];
     end;
     { / dtermine la matrice des contours aprs lissage }
     BitMapLis:=TBitMap.Create;
     with bitmaplis do begin
          width:=mos_imax*8;
          height:=mos_jmax*8;
          for i:=1 to mos_imax*8 do for j:=1 to mos_jmax*8 do
          if (i+j>8) and (i+j<(mos_imax+mos_jmax)*8-9) and (j-i+mos_imax*8>8) and (j-i<mos_jmax*8-9) then
          canvas.pixels[i-1,j-1]:=round((cont_lis[trunc((i+j)/8),trunc((j-i)/8+mos_imax)]-min)/(max-min)*255)*65793
          else canvas.pixels[i-1,j-1]:=0;
     end;
     image3.picture.graphic:=bitmaplis;
     image3.autosize:=true;
     image3.autosize:=false;
     image3.stretch:=true;
     image3.width:=round(image3.width/8);
     image3.height:=round(image3.height/8);
     lisse.checked:=true;
     lisse.enabled:=false;
     seuil_.enabled:=true;
end;

procedure TForm1.seuil_Click(Sender: TObject);
var
   i,j:integer;
   min,max,seuil:real;
   point_,point_ilot,point0:pTPoint_;
   ilot,ilot0:pTIlot;
begin
     min:=1000000;
     max:=-1000000;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_lis[i,j]>max then max:=cont_lis[i,j];
         if cont_lis[i,j]<min then min:=cont_lis[i,j];
     end;
     seuil:=min+(max-min)*3/4;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then begin
         if cont_lis[i,j]>seuil then cont_seuil[i,j]:=1 else cont_seuil[i,j]:=0;
     end else cont_seuil[i,j]:=0;
     { attribue les points au-dessus du seuil  des ilots de points connexes }
     liste_ilots:=nil;
     for i:=1 to cont_max do for j:=1 to cont_max do
     if (i+j>mos_imax-1) and (i+j<2*cont_max-mos_imax+3)
     and (j+cont_max-i>mos_jmax-2) and (j+cont_max-i<2*cont_max-mos_jmax+2) then if cont_seuil[i,j]>0 then begin
         new(point_);
         point_^.x:=i;
         point_^.y:=j;
         point_^.point_suivant:=nil;
         point_^.isole:=true;
         ilot:=liste_ilots;
         while ilot<>nil do begin
               point_ilot:=ilot^.liste_points;
               while point_ilot<>nil do begin
                     if ((point_ilot^.x=point_^.x) and (abs(point_ilot^.y-point_^.y)=1))
                     or ((point_ilot^.y=point_^.y) and (abs(point_ilot^.x-point_^.x)=1)) then begin
                        if point_^.isole=true then begin
                           { attribue point_  un ilot existant }
                           point_^.point_suivant:=ilot^.liste_points;
                           ilot^.liste_points:=point_;
                           point_ilot:=nil;
                           point_^.isole:=false;
                           { / attribue point_  un ilot existant }
                        end else begin
                            { recherche l'autre ilot auquel point_ appartient }
                            ilot0:=liste_ilots;
                            point0:=ilot0^.liste_points;
                            while (ilot0<>nil) and (point0<>point_) do begin
                                  point0:=ilot0^.liste_points;
                                  while (point0<>nil) and (point0<>point_) do point0:=point0^.point_suivant;
                                  if point0<>point_ then ilot0:=ilot0^.ilot_suivant;
                            end;
                            { / recherche l'autre ilot auquel point_ appartient }
                            { ajoute tous les points de ilot0  ilot puis dtruit ilot }
                            point0:=ilot0^.liste_points;
                            if point0<>nil then begin
                               while point0^.point_suivant<>nil do point0:=point0^.point_suivant;
                               point0^.point_suivant:=ilot^.liste_points;
                               ilot^.liste_points:=ilot0^.liste_points;
                               if liste_ilots<>ilot0 then begin
                                  ilot:=liste_ilots;
                                  if ilot<>nil then begin
                                     while ilot^.ilot_suivant<>ilot0 do ilot:=ilot^.ilot_suivant;
                                     ilot^.ilot_suivant:=ilot0^.ilot_suivant;
                                     dispose(ilot0);
                                  end;
                               end else begin
                                   liste_ilots:=liste_ilots^.ilot_suivant;
                                   dispose(ilot0);
                               end;
                            end;
                            { / ajoute tous les points de ilot  ilot0 puis dtruit ilot }
                        end;
                     end else point_ilot:=point_ilot^.point_suivant;
               end;
               ilot:=ilot^.ilot_suivant;
         end;
         if point_^.isole=true then begin
            new(ilot);
            ilot^.liste_points:=point_;
            ilot^.ilot_suivant:=liste_ilots;
            liste_ilots:=ilot;
         end;
     end;
     { / attribue les points au-dessus du seuil  des ilots de points connexes }
     BitMapLis:=TBitMap.Create;
     with bitmaplis do begin
          width:=mos_imax*8;
          height:=mos_jmax*8;
          for i:=1 to mos_imax*8 do for j:=1 to mos_jmax*8 do
          if (i+j>8) and (i+j<(mos_imax+mos_jmax)*8-9) and (j-i+mos_imax*8>8) and (j-i<mos_jmax*8-9) then begin
             canvas.pixels[i-1,j-1]:=round(cont_seuil[trunc((i+j)/8),trunc((j-i)/8+mos_imax)])*255*65793;
          end else canvas.pixels[i-1,j-1]:=0;
     end;
     image4.picture.graphic:=bitmaplis;
     image4.autosize:=true;
     image4.autosize:=false;
     image4.stretch:=true;
     image4.width:=round(image4.width/8);
     image4.height:=round(image4.height/8);
     seuil_.checked:=true;
     seuil_.enabled:=false;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     sh:=shift;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     sh:=shift;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
     with image1 do begin
          if sh=[] then begin
             stretch:=true;
             width:=width*2;
             height:=height*2;
          end;
          if sh=[ssAlt] then begin
             stretch:=true;
             width:=round(width/2);
             height:=round(height/2);
          end;
     end;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
     with image2 do begin
          if sh=[] then begin
             stretch:=true;
             width:=width*2;
             height:=height*2;
          end;
          if sh=[ssAlt] then begin
             stretch:=true;
             width:=round(width/2);
             height:=round(height/2);
          end;
     end;
end;

procedure TForm1.Image3Click(Sender: TObject);
begin
     with image3 do begin
          if sh=[] then begin
             stretch:=true;
             width:=width*2;
             height:=height*2;
          end;
          if sh=[ssAlt] then begin
             stretch:=true;
             width:=round(width/2);
             height:=round(height/2);
          end;
     end;
end;

procedure TForm1.Image4Click(Sender: TObject);
begin
     with image4 do begin
          if sh=[] then begin
             stretch:=true;
             width:=width*2;
             height:=height*2;
          end;
          if sh=[ssAlt] then begin
             stretch:=true;
             width:=round(width/2);
             height:=round(height/2);
          end;
     end;
end;

procedure TForm1.Nouveau1Click(Sender: TObject);
begin
     NouveauClick(sender);
     Mosaique_Click(sender);
     ContoursClick(sender);
     LisseClick(sender);
     Seuil_Click(sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     randomize;
end;

procedure TForm1.pickitup(i,j:integer);
var
   x,y,ii,jj,n,maxi,num_ilot:integer;
   peek:TPeek;
   max:real;
   deja,found:boolean;
   ilot:pTIlot;
   point_:pTPoint_;
begin
     peek[0,1]:=0;
     for ii:=-2 to 2 do for jj:=-2 to 2 do
     if (i+ii>0) and (i+ii<mos_imax+1) and (j+jj>0) and (j+jj<mos_jmax+1) then begin
        deja:=false;
        if peek[0,1]<>0 then for n:=1 to peek[0,1] do
        if peek[n,1]=mosaique[i+ii,j+jj] then begin
           peek[n,2]:=peek[n,2]+1;
           deja:=true;
        end;
        if deja=false then begin
           peek[0,1]:=peek[0,1]+1;
           peek[peek[0,1],1]:=mosaique[i+ii,j+jj];
           peek[peek[0,1],2]:=1;
        end;
     end;
     Memo1.Clear;
     if seuil_.checked=true then begin
        x:=i+j-1;
        y:=j-i+mos_imax-1;
        found:=false;
        ilot:=liste_ilots;
        num_ilot:=0;
        while (ilot<>nil) and (found=false) do begin
              num_ilot:=num_ilot+1;
              point_:=ilot^.liste_points;
              while point_<>nil do begin
                    if (point_^.x=x) and (point_^.y=y) then found:=true;
                    point_:=point_^.point_suivant;
              end;
              if found=false then ilot:=ilot^.ilot_suivant;
        end;
        if found=true then Memo1.Lines.Add('   Ilot n'+inttostr(num_ilot)) else Memo1.Lines.Add('   Hors Ilots');
     end;
     for n:=1 to peek[0,1] do begin
         max:=0;
         maxi:=0;
         for ii:=1 to peek[0,1] do if peek[ii,2]>max then begin
             max:=peek[ii,2];
             maxi:=ii;
         end;
         if peek[maxi,1]<>mosaique[i,j] then Memo1.Lines.Add('  '+noeuds[peek[maxi,1]]+'   ('+inttostr(peek[maxi,2])+')')
         else Memo1.Lines.Add('> '+noeuds[peek[maxi,1]]+'   ('+inttostr(peek[maxi,2])+')');
         peek[maxi,2]:=0;
     end;
end;
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if mosaique_.checked=true then with image1 do begin
        labelXnum.Caption:=inttostr(x)+'/'+inttostr(width);
        labelYnum.caption:=inttostr(y)+'/'+inttostr(height);
        pickitup(1+round(x/(width-1)*(mos_imax-1)),1+round(y/(height-1)*(mos_jmax-1)));
     end;
end;

procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if contours.checked=true then with image2 do begin
        labelXnum.Caption:=inttostr(x)+'/'+inttostr(width);
        labelYnum.caption:=inttostr(y)+'/'+inttostr(height);
        pickitup(1+round(x/(width-1)*(mos_imax-1)),1+round(y/(height-1)*(mos_jmax-1)));
     end;
end;

procedure TForm1.Image3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if lisse.checked=true then with image3 do begin
        labelXnum.Caption:=inttostr(x)+'/'+inttostr(width);
        labelYnum.caption:=inttostr(y)+'/'+inttostr(height);
        pickitup(1+round(x/(width-1)*(mos_imax-1)),1+round(y/(height-1)*(mos_jmax-1)));
     end;
end;

procedure TForm1.Image4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if seuil_.checked=true then with image4 do begin
        labelXnum.Caption:=inttostr(x)+'/'+inttostr(width);
        labelYnum.caption:=inttostr(y)+'/'+inttostr(height);
        pickitup(1+round(x/(width-1)*(mos_imax-1)),1+round(y/(height-1)*(mos_jmax-1)));
     end;
end;

end.

{ lissage elliptique }
 {     for i:=1 to contimax do for j:=1 to contjmax do
     if cont_bas[i,j]<>0 then begin
         xx:=0;
         xy:=0;
         yy:=0;
         for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
         if (i+ii)>0 then
         if (i+ii)<contimax+1 then
         if (j+jj)>0 then
         if (j+jj)<contjmax+1 then begin
            facteur:=1+((ii*ii)*sqr(50/mos_imax)+(jj*jj)*sqr(50/mos_jmax));
            xx:=xx+ii*ii*cont_bas[i+ii,j+jj]/facteur;
            xy:=xy+ii*jj*cont_bas[i+ii,j+jj]/facteur;
            yy:=yy+jj*jj*cont_bas[i+ii,j+jj]/facteur;
         end;
         for ii:=-maxii to maxii do for jj:=-maxjj to maxjj do
         if (i+ii)>0 then
         if (i+ii)<contimax+1 then
         if (j+jj)>0 then
         if (j+jj)<contjmax+1 then if (xx+2*xy+yy)<>0 then begin
            facteur:=1+(xx*ii*ii*sqr(50/mos_imax)+2*xy*ii*jj*sqr(50)/mos_imax/mos_jmax+yy*jj*jj*sqr(50/mos_jmax))/(xx+2*xy+yy);
            cont_lis[i+ii,j+jj]:=cont_lis[i+ii,j+jj]-cont_bas[i,j]/facteur;
         end;
     end;
     { / dtermine la matrice des contours aprs lissage }

